include \masm32\include\masm32rt.inc

GetField MACRO SrcDotField		; trashes and returns eax
LOCAL is, is2, src, field
  is INSTR <SrcDotField>, <.>
  if is
	is2 INSTR is+1, <SrcDotField>, <.>
	if is2 gt is
		is = is2
	endif
  else
	.err <*** syntax: GetField(rec.field) ***>
  endif
  src SUBSTR <SrcDotField>, 1, is-1
  field SUBSTR <SrcDotField>, is+1
  ifdifi src, <eax>   
	mov eax, src
  endif
  and eax, mask field
  if field
	shr eax, field
  endif
  EXITM <eax>
ENDM

SetField MACRO SrcDotField, TheVal, forceAnd		; trashes and returns eax; checks immediate values for overflow
LOCAL is, is2, src, field, maxv
  is INSTR <SrcDotField>, <.>
  if is
	is2 INSTR is+1, <SrcDotField>, <.>
	if is2 gt is
		is = is2
	endif
  else
	.err <*** syntax: SetField rec.field, 123 ***>
  endif
  src SUBSTR <SrcDotField>, 1, is-1
  field SUBSTR <SrcDotField>, is+1
  if ((opattr(TheVal)) AND 127) eq 36
	maxv = 2 SHL (WIDTH field - 1)		;; or gt with maxv = mask field SHR field
	if TheVal ge maxv
		tmp$ CATSTR <** Line >, %@Line, <: overflow for SetField >, <SrcDotField>, <, >, <TheVal>, <, max=>, %maxv, < **>
		.err tmp$
	endif
  endif
  ifdifi <TheVal>, <eax>   
	mov eax, TheVal
  endif
  if field
	shl eax, field
  endif
  ifnb <forceAnd>
	and src, not mask field
  endif
  or src, eax
ENDM

CDROM_READ_TOC_EX_FORMAT_TOC equ 0

CDROM_READ_TOC_EX   struct
	CDROM_READ_TOC_EX_R0   RECORD   Format:4,Reserved1:3,Msf:1
	CDROM_READ_TOC_EX_R0 <>
	SessionTrack   UCHAR   ?
	Reserved2   UCHAR   ?
	Reserved3   UCHAR   ?
CDROM_READ_TOC_EX   ends

.data
tocex CDROM_READ_TOC_EX <>

.code
start:
	SetField tocex.CDROM_READ_TOC_EX.Format, CDROM_READ_TOC_EX_FORMAT_TOC
	SetField tocex.CDROM_READ_TOC_EX.Msf, 1
	print str$(GetField(tocex.CDROM_READ_TOC_EX.Format, CDROM_READ_TOC_EX_FORMAT_TOC)), 9, "Format", 13, 10
	print str$(GetField(tocex.CDROM_READ_TOC_EX.Msf, CDROM_READ_TOC_EX_FORMAT_TOC)), 9, "Msf", 13, 10
	getkey
	exit
end start

OPT_Wait	0
OPT_Tmp2Asm	1

